package expandedcpvwrapper;

import com.tigerlee.widget.ExpandedCircleProgressView;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.util.DisplayMetrics;
import android.view.ViewGroup;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
import anywheresoftware.b4a.BA.Events;
import android.view.MotionEvent;

import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnLongClickListener;
import android.view.View.OnTouchListener;
import android.view.ViewParent;


import android.graphics.BitmapShader;
import android.graphics.Shader;
import android.graphics.drawable.ShapeDrawable;
import android.graphics.drawable.shapes.RectShape;

@Author("Johan Schoeman")
@Version(1.00f)
@ShortName("ExpandedCircleProgressView")
public class expandedCPVWrapper extends ViewWrapper<ExpandedCircleProgressView> implements DesignerCustomView {
//public class expandedCPVWrapper implements DesignerCustomView {

	private BA ba;
	private String eventName;
        private ExpandedCircleProgressView cv;
	
	/*
	 * Initialize the HTML-TextView 
	 */   


	
	public void Initialize(BA ba, String EventName) {
		_initialize(ba, null, EventName);
	}

	@Hide
	public void _initialize(BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
		cv = new ExpandedCircleProgressView(ba.context);
                this.setObject(cv);
//                setEventName(this.eventName);
//                addListener();
 	}


//        @Hide
//        public void setEventName(String en){
//            cv.setEventName(en);
//            cv.invalidate(); 
//       }


//    @Hide
//    public void addListener(){
//        cv.setCallback(new DownloadProgressBar.Callback() {
//            @Override
//            public void complete() {

//              if (ba.subExists(eventName + "_completed")) {
//                ba.raiseEvent2(ba, false, eventName + "_completed", true, new Object[0]);
//              }
//            }

//            @Override
//            public void started() {

//              if (ba.subExists(eventName + "_click")) {
//                ba.raiseEvent2(ba, false, eventName + "_click", true, new Object[0]);
//              }
//            }


//        });
//    }

	
	//programmatically add view
        @Hide
	public void AddToParent(ViewGroup Parent, @Pixel int left, @Pixel int top, @Pixel int width, @Pixel int height) {
		Parent.addView(cv, new BALayout.LayoutParams(left, top, width, height));
	}
	
	//this method cannot be hidden.
  
        
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, anywheresoftware.b4a.objects.collections.Map props) {
		ViewGroup vg = (ViewGroup) base.getObject().getParent();
		AddToParent(vg, base.getLeft(), base.getTop(), base.getWidth(), base.getHeight());
		base.RemoveView();
		//set text properties
	}



	public void setLeft(int left)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.left = left;
		cv.getParent().requestLayout();
	}

	public int getLeft()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.left;
	}
	public void setTop(int top)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.top = top;
		cv.getParent().requestLayout();
	}
 
	public int getTop()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.top;
	}
	
	public void setWidth(int Width)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.width = Width;
		cv.getParent().requestLayout();
	}

	public int getWidth()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.width;
	}
	
	public void setHeight(int height)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.height = height;
		cv.getParent().requestLayout();
	}

	public int getHeight()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.height;
	}



	/**
	 * Set size of the inner circle
	 * @param size size of the inner circle
	 */
	public void setInnerCircleSize(float size){
		cv.setInnerCircleSize(size);
		cv.invalidate();
	}
	/**
	 * Set size of the outer circle
	 * @param size size of the outer circle
	 */
	public void setOuterCircleSize(float size){
		cv.setOuterCircleSize(size);
		cv.invalidate();
	}

	/**
	 * Set color of the inner circle
	 * @param color color of the inner circle
	 */
	public void setInnerCircleColor(int color) {
		cv.setInnerCircleColor(color);
                cv.invalidate();
	}

	/**
	 * Set color of the outer circle
	 * @param color color of the outer circle
	 */
	public void setOuterCircleColor(int color) {
		cv.setOuterCircleColor(color);
                cv.invalidate();
	}

	/**
	 * Set color of the progress text 
	 * @param color color of the progress text 
	 */
	public void setProgressTextColor(int color) {
		cv.setProgressTextColor(color);
                cv.invalidate();
	}

	/**
	 * Set color of circle of expanding progress  
	 * @param color color of circle of expanding progress 
	 */
	public void setProgressColor(int color) {
		cv.setProgressColor(color);
                cv.invalidate();
	}
	
	/**
	 * Set width of the outer circle line
	 * @param width width of the outer circle line
	 */
	public void setOuterCircleLineWidth(float width) {
		cv.setOuterCircleLineWidth(width);
                cv.invalidate();
	}
	
	/**
	 * Set size of the progress text
	 * @param size size of the progress text
	 */
	public void setTextProgressSize(float size) {
		cv.setTextProgressSize(size);
                cv.invalidate();
	}

	/**
	 * get maximum value of progress
	 * @return maximum value of progress
	 */
	public int getMaxProgress() {
                return cv.getMaxProgress();
	}

	/**
	 * set current progress 
	 * @param progress set progress from 0 to max progress(100)
	 */
	public void setProgress(int progress) {
               cv.setProgress(progress);
               cv.invalidate();
	}

	public void cancelUpdateTask() {
            cv.cancelUpdateTask();
            cv.invalidate();
        }
	
}
